#ifndef MATRIX_ADDONS_INC
#define MATRIX_ADDONS_INC

#include "matrix.h"

namespace Torch {

/** @name Additional matrix functions
 
    @author Sebastien Marcel (marcel@idiap.ch)
    \Date
    @version 2.0
    @since 1.0
*/
//@{
/** compute vector-vector multiplication
    
    @param X_ a vector #X#
    @param T_Y_ the transpose of a vector #Y#
    @param M_ the matrix $X Y^T$
*/
void mxVecMulTrVec(Vec *X_, Vec *T_Y_, Mat *M_);

/// print a vector (float)
void printV(int n, float *vec);

/// print a vector (double)
void printV(int n, double *vec);

/// print a vector
void printV(Vec *vec);

/// print a matrix
void printM(Mat *mat);

/// copy a matrix into another one
void mxCopy(Mat *A, Mat *B, int h_target, int w_target, int h_begin, int w_begin, int h_end, int w_end);

/// product of elements of 2 matrices
void mxMulMat(Mat * mat1, Mat * mat2, Mat * out);

/// rescale matrix elements between zero and #scale_#
void mxScale(Mat *mat, real scale_ = 255.0);
   
//@}
}

#endif
