const char *help = "\
progname: onoff.cc\n\
code2html: This program switch ON/OFF a Sony pan/til/zoom camera using a VISCA serial interface.\n\
version: Torch3 vision2.0, 2003-2005\n\
(c) Sebastien Marcel (marcel@idiap.ch)\n";

#include "SonyEviD31.h"
#include "SonyEviD100P.h"

using namespace Torch;

int main(int argc, char **argv)
{
	print("SonyEviD100P on /dev/ttyS%s\n", argv[1]);

	SonyEviD100P camera("/dev/ttyS", argv[1][0]);

	if(camera.connect() == false) return 0;
	      
	int powerStatus;
	bool isOn;
	bool isOff;
	
	print("Trying to get the power status of the camera.\n");
	powerStatus = camera.getPowerStatus();

	switch(powerStatus)
	{
	case -1: print("Error couldn't get the power status.\n");
		 break;
	case 0: print("The camera is OFF.\n");
		isOn = camera.setPowerOn();
		if(isOn == true) 
		{
			print("Camera should be on now !\n");

			camera.goHome();
		}
		 break;
	case 1: print("The camera is ON.\n");
		isOff = camera.setPowerOff();
		if(isOff == true) print("Camera should be off now !\n");
		 break;
	default: print("Unexpected value.\n");
	}

	
	
	return 1;
}
