#ifndef GEOM_OBJECT_INC
#define GEOM_OBJECT_INC

#include "Image.h"
#include "XFile.h"

#ifdef HAVE_X11
#include "X.h"
#endif

namespace Torch {

/** This class is designed to handle geometry objects and algorithms

    @author Sebastien Marcel (marcel@idiap.ch)

    @version 2.0
    \Date
    @since 1.0
*/
class geomObject
{
protected:
	char buf_sprint[250];

public:
	/// verbose
   	bool verbose;
	
	//-----
	
	/// constructor
	geomObject() { verbose = false; }
	
	/// destructor
	virtual ~geomObject() {};

	//-----
	
	/// save
	virtual void saveXFile(XFile *file) = 0;

	/// load
	virtual void loadXFile(XFile *file) = 0;
	
	//-----
	
	/// print
	virtual const char *sprint() = 0;

	//-----
	
	/// draw the object on an image
	virtual void draw(Image *image_, Color color_) = 0;

#ifdef HAVE_X11
	/// draws the object on an X11 display
	virtual void xdraw(Display *pDisplay_, Pixmap pixmap_, GC gc_, unsigned long color_) {};
#endif
};

}

#endif 
