#ifndef PCA_MACHINE_INC
#define PCA_MACHINE_INC

#include "EigenMachine.h"

namespace Torch {

/** This class is designed to handle Principal Component Analysis (PCA)

    @author Sebastien Marcel (marcel@idiap.ch)
    @version 2.0
    \Date
    @since 2.0

    @see PCATrainer
*/
class PCAMachine : public EigenMachine
{  
   	//
	real *input_; 

public:

   	/// Mean vector
   	real *Xm;

	//-----

	///
	PCAMachine(int n_inputs_);	

	///
	virtual ~PCAMachine();

	/// computes the projection of the input onto the PCA matrix
	virtual void forward(Sequence *inputs);

	/// load the parameters of the PCA
	virtual void loadXFile(XFile *file);

	/// save the parameters of the PCA
	virtual void saveXFile(XFile *file);
};

}

#endif
