#ifndef PYRAMID_WINDOW_SCAN_INC
#define PYRAMID_WINDOW_SCAN_INC

#include "WindowScan.h"
#include "ipScale_yx.h"

namespace Torch {

/** This class is designed to perform pyramid image scanning (subsampling)

    @author Sebastien Marcel (marcel@idiap.ch)
    @author Yann Rodriguez (rodrig@idiap.ch)
    \Date
    @version 2.0
    @since 1.0
*/
class PyramidWindowScan : public WindowScan 
{
public:
	/// value of the current scale
	real scale;
	
	/// subsampling machine (NULL if not used)
	ipScale_yx *subsampling;

	/// output of the subsampling
	Sequence *subsample_image;

	///
	PyramidWindowScan(	int width_image_, int height_image_, 
				int real_width_image_, int real_height_image_, 
				int width_pattern_, int height_pattern_, 
				int real_width_pattern_, int real_height_pattern_, 
				real stepx_factor_, real stepy_factor_, 
				ipSubWindow *ip_sw_, 
				PatternCollector *patterncollector_,
				real scale_,
				bool verbose = false);

	///
	virtual void init(void);

	///
	virtual void process(Sequence *seq_in);

	///
	virtual ~PyramidWindowScan();
};

}

#endif
