#ifndef EIGEN_TRAINER_INC
#define EIGEN_TRAINER_INC

#include "matrix.h"
#include "matrix_addons.h"

namespace Torch {

/** This structure is designed to sort data (double)

    #the_int# contains generally the index of a structured object,
    while #the_real# contains the value by which we wish to sort the objects.

    @author Sebastien Marcel (marcel@idiap.ch)

    @version 2.0
    \Date
    @since 1.0

    @see Int_real
*/
struct int_double 
{
	int the_int;
	real the_real;
};

/** Additional functions to sort eigenvalues in double precision

    @author Sebastien Marcel (marcel@idiap.ch)
    \Date
    @version 2.0
    @since 1.0
*/
//@{
extern "C"
{
/// sort an int_double in increasing order
int sort_inc_int_double(const void *p1, const void *p2);

/// sort an int_double in decreasing order
int sort_dec_int_double(const void *p1, const void *p2);
}
//@}

}

#endif
