#ifndef IO_VIRTUAL_INC
#define IO_VIRTUAL_INC

#include "IOSequence.h"

namespace Torch {

/** This class is designed to handle a virtual IOSequence

    @author Yann Rodriguez (rodrig@idiap.ch)
    \Date
    @version 2.0
    @since 1.0
*/
class IOVirtual : public IOSequence
{
private:
	//
	real target;

public:
	///
	IOVirtual(real target_, int n_sequences_);

	///
	virtual void getSequence(int t, Sequence *sequence);

	///
	virtual int getNumberOfFrames(int t);

	///
	virtual int getTotalNumberOfFrames();

	///
	virtual ~IOVirtual();
};

}

#endif
